// Code generated by go-swagger; DO NOT EDIT.

package engines

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/ory/keto/internal/httpclient/models"
)

// NewDoOryAccessControlPoliciesAllowParams creates a new DoOryAccessControlPoliciesAllowParams object
// with the default values initialized.
func NewDoOryAccessControlPoliciesAllowParams() *DoOryAccessControlPoliciesAllowParams {
	var ()
	return &DoOryAccessControlPoliciesAllowParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewDoOryAccessControlPoliciesAllowParamsWithTimeout creates a new DoOryAccessControlPoliciesAllowParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewDoOryAccessControlPoliciesAllowParamsWithTimeout(timeout time.Duration) *DoOryAccessControlPoliciesAllowParams {
	var ()
	return &DoOryAccessControlPoliciesAllowParams{

		timeout: timeout,
	}
}

// NewDoOryAccessControlPoliciesAllowParamsWithContext creates a new DoOryAccessControlPoliciesAllowParams object
// with the default values initialized, and the ability to set a context for a request
func NewDoOryAccessControlPoliciesAllowParamsWithContext(ctx context.Context) *DoOryAccessControlPoliciesAllowParams {
	var ()
	return &DoOryAccessControlPoliciesAllowParams{

		Context: ctx,
	}
}

// NewDoOryAccessControlPoliciesAllowParamsWithHTTPClient creates a new DoOryAccessControlPoliciesAllowParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewDoOryAccessControlPoliciesAllowParamsWithHTTPClient(client *http.Client) *DoOryAccessControlPoliciesAllowParams {
	var ()
	return &DoOryAccessControlPoliciesAllowParams{
		HTTPClient: client,
	}
}

/*DoOryAccessControlPoliciesAllowParams contains all the parameters to send to the API endpoint
for the do ory access control policies allow operation typically these are written to a http.Request
*/
type DoOryAccessControlPoliciesAllowParams struct {

	/*Body*/
	Body *models.OryAccessControlPolicyAllowedInput
	/*Flavor
	  The ORY Access Control Policy flavor. Can be "regex", "glob", and "exact".

	*/
	Flavor string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the do ory access control policies allow params
func (o *DoOryAccessControlPoliciesAllowParams) WithTimeout(timeout time.Duration) *DoOryAccessControlPoliciesAllowParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the do ory access control policies allow params
func (o *DoOryAccessControlPoliciesAllowParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the do ory access control policies allow params
func (o *DoOryAccessControlPoliciesAllowParams) WithContext(ctx context.Context) *DoOryAccessControlPoliciesAllowParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the do ory access control policies allow params
func (o *DoOryAccessControlPoliciesAllowParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the do ory access control policies allow params
func (o *DoOryAccessControlPoliciesAllowParams) WithHTTPClient(client *http.Client) *DoOryAccessControlPoliciesAllowParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the do ory access control policies allow params
func (o *DoOryAccessControlPoliciesAllowParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the do ory access control policies allow params
func (o *DoOryAccessControlPoliciesAllowParams) WithBody(body *models.OryAccessControlPolicyAllowedInput) *DoOryAccessControlPoliciesAllowParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the do ory access control policies allow params
func (o *DoOryAccessControlPoliciesAllowParams) SetBody(body *models.OryAccessControlPolicyAllowedInput) {
	o.Body = body
}

// WithFlavor adds the flavor to the do ory access control policies allow params
func (o *DoOryAccessControlPoliciesAllowParams) WithFlavor(flavor string) *DoOryAccessControlPoliciesAllowParams {
	o.SetFlavor(flavor)
	return o
}

// SetFlavor adds the flavor to the do ory access control policies allow params
func (o *DoOryAccessControlPoliciesAllowParams) SetFlavor(flavor string) {
	o.Flavor = flavor
}

// WriteToRequest writes these params to a swagger request
func (o *DoOryAccessControlPoliciesAllowParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param flavor
	if err := r.SetPathParam("flavor", o.Flavor); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
